### 
### Estimation of the sample mean and standrad deviation
### according to Luo et al. (2018) and Shi et al (2018)
###
###


est.sample.mean <- function(quantiles, n){
  min <- quantiles[1]; q1<- quantiles[2]; median<- quantiles[3]; q3<- quantiles[4]; max<- quantiles[5];
  w1 <- 2.2 / (2.2 + n^(0.75))
  w2 <- 0.7 - 0.72 / n^(0.55)
  
  return( w1 * (min+max)/2 + w2 * (q1+q3)/2 + (1-w1-w2)*median )
  
}

est.sample.sd <- function(quantiles, n, method){
  min <- quantiles[1]; q1<- quantiles[2]; median<- quantiles[3]; q3<- quantiles[4]; max<- quantiles[5];
  
  if(method=="Wan"){
    zeta1 <- 4 * qnorm( (n-0.375)/(n+0.25) ) 
    zeta2 <- 4 * qnorm( (0.75*n-0.125)/(n+0.25) ) 
  }
  if(method=="Shi"){
    zeta1 <- (2 + 0.14 * n^(0.6)) * qnorm( (n-0.375)/(n+0.25) )
    zeta2 <- (2 + 2/(0.07 * n^(0.6))) * qnorm( (0.75*n-0.125)/(n+0.25) )
  }
  
  return( (max-min)/zeta1 + (q3-q1)/zeta2 )
  
}