#
#
#
# Code to draw plots for:
# - Each of the three possible constructions of bivariate (min-max) intervals
# -- 2 points
# -- 3 points
# -- 4 points
#
# Plots used for the top row of Figure 1.
#

library(mvtnorm)

rho <- c(0.95, -0.5, 0)
n <- 20

for(i in 1:length(rho)){
  
  Rho <- rho[i]
  Cov <- matrix(c(1,Rho,Rho,1), ncol=2)
  #set.seed(101)
  d <- rmvnorm(n=n, sigma=Cov)
  Xlim <- range(d[,1])*1.3
  Ylim <- range(d[,2])*1.3
  Min <- apply(d,2,min)
  Max <- apply(d,2,max)
  
  par(mfrow=c(1,1), mar=c(2, 2.4, 0.5, 0.5))
  plot(d, xlim=Xlim, ylim=Ylim, xlab="", ylab="", pch=16, cex=1.0, cex.axis=1.5,axes=F,main=paste(expression(rho)," = ",n))
  segments(Min[1], Min[2], Min[1], Max[2], lwd=2)
  segments(Min[1], Max[2], Max[1], Max[2], lwd=2)
  segments(Max[1], Max[2], Max[1], Min[2], lwd=2)
  segments(Max[1], Min[2], Min[1], Min[2], lwd=2)
  dev.copy2pdf(file=paste("biv_int_",i+1,"pts.pdf",sep=""))
  
}

