#
#
#
# Code to draw plots for:
# - Each of the four constructions of bivariate intervals using order statistics and from the margins
# -- L_{is,x}
# -- L_{is,y}
# -- L_{sn,x}
# -- L_{sn_y}
# -- L_{marginal}
#
# Plots used for the bottom row of Figure 1.
#

par(mfrow=c(1,1), mar=c(0.5, 0.5, 0.5, 0.5))
plot(0, -1, xlim=c(0, 14), ylim=c(0, 14),xlab="", ylab="", axes=FALSE)
polygon(x=c(4, 10, 10, 4), y=c(10, 10, 4, 4), col="grey", border=NA)
segments(4, 0, 4, 14, lwd=2, col = "blue" )
segments(10, 0, 10, 14, lwd=2, col = "blue" )
text(5, -0.2, expression( x[paste((l[1]), ",", 1)]), cex = 1.5)
text(11.1, -0.2, expression(x[paste((u[1]), ",", 1)]), cex = 1.5)
segments(0, 4, 4, 4, lwd=2, col = "blue" )
segments(4, 4, 10, 4, lty=2, lwd=2)
segments(4, 10, 10, 10, lty=2, lwd=2)
segments(10, 10, 14, 10, lwd=2, col = "blue" )
text(12.5, 10.5, expression(x[paste((u[2]), ",", 2)]), cex = 1.5)
text(2, 4.5, expression(x[paste((l[2]), ",", 2)]), cex = 1.5)
text(1.7, 10, expression(l[1]-l[2]-1), cex = 1.5, col = "blue" )
text(1.7, 2, expression(l[2]-1), cex = 1.5, col = "blue" )
text(7, 7, expression(u[1]-l[1]-1), cex = 1.5, col = "blue" )
text(12.2, 4, expression(u[2]-1), cex = 1.5, col = "blue" )
text(12.2, 12.2, expression(n-u[1]-u[2]), cex = 1.5, col = "blue" )
dev.copy2pdf(file="biv_int_const1x.pdf")

par(mfrow=c(1,1), mar=c(0.5,0.5,0.5,0.5))
plot(0,-1, xlim=c(0,14), ylim=c(0,14),xlab="", ylab="", axes=FALSE)
polygon(x=c(4,10,10,4), y=c(10,10,4,4), col="grey", border=NA)
segments(0, 4, 14, 4, lwd=2, col = "blue" )
segments(0, 10, 14, 10, lwd=2, col = "blue" )
text(5,-0.2, expression( x[paste((l[1]), ",", 1)]), cex=1.5)
text(11.1, 14, expression(x[paste((u[1]), ",", 1)]), cex=1.5)
segments(4, 0,4 , 4, lwd=2, col = "blue" )
segments(4, 4, 4, 10, lty=2, lwd=2)
segments(10, 4, 10, 10, lty=2, lwd=2)
segments(10, 10, 10, 14, lwd=2, col = "blue" )
text(1, 10.5, expression(x[paste((u[2]), ",", 2)]), cex=1.5)
text(1, 4.5, expression(x[paste((l[2]), ",", 2)]), cex=1.5)
text(1.7, 2, expression(l[1]-1), cex = 1.5, col = "blue" )
text(10, 2, expression(l[2]-l[1]-1), cex = 1.5, col = "blue" )
text(7, 7, expression(u[2]-l[2]-1), cex = 1.5, col = "blue" )
text(4, 12.2, expression(u[1]-1), cex = 1.5, col = "blue" )
text(12.2, 12.2, expression(n-u[2]-u[1]), cex = 1.5, col = "blue" )
dev.copy2pdf(file="biv_int_const1y.pdf")

par(mfrow=c(1,1), mar=c(0.5,0.5,0.5,0.5))
plot(0,-1, xlim=c(0,14), ylim=c(0,14),xlab="", ylab="", axes=FALSE)
polygon(x=c(4,10,10,4), y=c(10,10,4,4), col="grey", border=NA)
segments(4,0,4,14, lwd=2, col = "blue" )
segments(10,0,10,14, lwd=2, col = "blue" )
text(5,-0.2, expression( x[paste((l[1]), ",", 1)]), cex=1.5)
text(11.1,-0.2, expression(x[paste((u[1]), ",", 1)]), cex=1.5)
segments(4,4,10,4, lwd=2, col = "blue" )
segments(4,10,10,10, lwd=2, col = "blue" )
text(2.7,10, expression(x[paste((u[2]), ",", 2)]), cex=1.5)
text(2.7,4, expression(x[paste((l[2]), ",", 2)]), cex=1.5)
text(1.7, 7, expression(l[1]-1), cex = 1.5, col = "blue" )
text(7, 2, expression(l[2]-1), cex = 1.5, col = "blue" )
text(7, 7, expression(u[2]-l[2]-1), cex = 1.5, col = "blue" )
text(7, 12.2, expression(u[1]-u[2]-l[1]-1), cex = 1.5, col = "blue" )
text(12.2, 7, expression(n-u[1]), cex = 1.5, col = "blue" )
dev.copy2pdf(file="biv_int_const2x.pdf")

par(mfrow=c(1,1), mar=c(0.5,0.5,0.5,0.5))
plot(0,-1, xlim=c(0,14), ylim=c(0,14),xlab="", ylab="", axes=FALSE)
polygon(x=c(4,10,10,4), y=c(10,10,4,4), col="grey", border=NA)
segments(0, 4, 14, 4, lwd=2, col = "blue" )
segments(0, 10, 14, 10, lwd=2, col = "blue" )
text(4,3.5, expression( x[paste((l[1]), ",", 1)]), cex=1.5)
text(10, 3.5, expression(x[paste((u[1]), ",", 1)]), cex=1.5)
segments(4, 4, 4, 10, lwd=2, col = "blue" )
segments(10, 4, 10, 10, lwd=2, col = "blue" )
text(1, 10.5, expression(x[paste((u[2]), ",", 2)]), cex=1.5)
text(1, 4.5, expression(x[paste((l[2]), ",", 2)]), cex=1.5)
text(7, 2, expression(l[2]-1), cex = 1.5, col = "blue" )
text(7, 7, expression(u[1]-l[1]-1), cex = 1.5, col = "blue" )
text(7, 12.2, expression(n-u[2]), cex = 1.5, col = "blue" )
text(1.7, 7, expression(l[1]-1), cex = 1.5, col = "blue" )
text(12.3, 7, expression(u[2]-u[1]-l[2]-1), cex = 1.3, col = "blue" )
dev.copy2pdf(file="biv_int_const2y.pdf")


par(mfrow=c(1,1), mar=c(0.5,0.5,0.5,0.5))
plot(0,-1, xlim=c(0,14), ylim=c(0,14),xlab="", ylab="", axes=FALSE)
polygon(x=c(4,4,0,0,4,4,10,10,14,14,10,10,4), y=c(0,4,4,10,10,14,14,10,10,4,4,0,0), col="grey", border=NA)
segments(0, 4, 14, 4, lwd=2, col=2)
segments(0, 10, 14, 10, lwd=2, col=2)
text(4,-0.2, expression( x[paste((l[1]), ",", 1)]), cex=1.5)
text(10, -0.2, expression(x[paste((u[1]), ",", 1)]), cex=1.5)
segments(4, 0, 4, 14, lwd=2, col=4)
segments(10, 0, 10, 14, lwd=2, col=4)
text(1, 10.5, expression(x[paste((u[2]), ",", 2)]), cex=1.5)
text(1, 4.5, expression(x[paste((l[2]), ",", 2)]), cex=1.5)
text(7, 7.4, expression(u[1]-l[1]-1), cex = 1.5, col = "blue" )
text(1.7, 7, expression(l[1]-1), cex = 1.5, col = "blue" )
text(12.3, 7, expression(n-u[1]), cex = 1.3, col = "blue" )

text(7, 2, expression(l[2]-1), cex = 1.5, col = 2 )
text(7, 6.6, expression(u[2]-l[2]-1), cex = 1.5, col = 2 )
text(7, 12.2, expression(n-u[2]), cex = 1.5, col = 2 )
dev.copy2pdf(file="biv_int_marginal.pdf")


