#
#
#
# Interpretation of the results from 
#	script_biv_os_int.R 
#	script_biv_os1_int.R
#
#
#

ns <- c(60,300) 
m <- 20
mean <- c(2,5)
var <- c(0.5^2, 0.5^2)
Cor <- c(-0.7, 0, 0.7)
Cov <- Cor * prod(sqrt(var))

Orders.x <- rbind(c(6, 55, 3, 3), c(16, 45, 10, 2), c(20, 41, 7, 14))
Orders.y <- rbind(c(3, 3, 6, 55), c(10, 2, 16, 45), c(7, 14, 20, 41))
Orders2.x <- rbind(c(6, 55, 5, 35), c(16, 45, 6, 24), c(20, 41, 5, 16))
Orders2.y <- rbind(c(5, 35, 6, 55), c(6, 24, 16, 45), c(5, 16, 20, 41))

for( k in 1:length(Cov)){
  cov=Cov[k]
  cat("\n Covariance: ", cov, "\n")
  
  res <- matrix(ncol=7, nrow=28*2)
  
  for( l in 1:nrow(Orders.x)){
    orders.x <- Orders.x[l,]
    
    load( paste("N_",m, "XSymb_", ns[1], "PtsSymb_",Cov[k],"Cov_",orders.x[1],"_",orders.x[2],"_",orders.x[3],"_",orders.x[4],"_orders.RData",sep="") )
    val.m <- round(c(mean(sqrt(est.os2.x[,3]),na.rm=TRUE), mean(est.os2.x[,6],na.rm=TRUE), mean(sqrt(est.os2.x[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+1, 1:3 ] <- format(val.m, nsmall=4)
    val.sd <- round(c(sd(sqrt(est.os2.x[,3]),na.rm=TRUE), sd(est.os2.x[,6],na.rm=TRUE), sd(sqrt(est.os2.x[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+2, 1:3 ] <- paste( "(",format(val.sd, nsmall=4), ")",sep="")
    
    orders.x <- orders.x *5 
    load( paste("N_",m, "XSymb_", ns[2], "PtsSymb_",Cov[k],"Cov_",orders.x[1],"_",orders.x[2],"_",orders.x[3],"_",orders.x[4],"_orders.RData",sep="") )
    val.m <- round(c(mean(sqrt(est.os2.x[,3]),na.rm=TRUE), mean(est.os2.x[,6],na.rm=TRUE), mean(sqrt(est.os2.x[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+1, 5:7 ] <- format(val.m, nsmall=4)
    val.sd <- round(c(sd(sqrt(est.os2.x[,3]),na.rm=TRUE), sd(est.os2.x[,6],na.rm=TRUE), sd(sqrt(est.os2.x[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+2, 5:7 ] <- paste( "(",format(val.sd, nsmall=4), ")",sep="")
    
  }  
  
  
  for( l in 1:nrow(Orders.y)){
    orders.y <- Orders.y[l,]
    
    load( paste("N_",m, "YSymb_", ns[1], "PtsSymb_",Cov[k],"Cov_",orders.y[1],"_",orders.y[2],"_",orders.y[3],"_",orders.y[4],"_orders.RData",sep="") )
    val.m <- round(c(mean(sqrt(est.os2.y[,3]),na.rm=TRUE), mean(est.os2.y[,6],na.rm=TRUE), mean(sqrt(est.os2.y[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+15, 1:3 ] <- format(val.m, nsmall=4)
    val.sd <- round(c(sd(sqrt(est.os2.y[,3]),na.rm=TRUE), sd(est.os2.y[,6],na.rm=TRUE), sd(sqrt(est.os2.y[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+16, 1:3 ] <- paste( "(",format(val.sd, nsmall=4), ")",sep="")
    
    orders.y <- orders.y *5 
    load( paste("N_",m, "YSymb_", ns[2], "PtsSymb_",Cov[k],"Cov_",orders.y[1],"_",orders.y[2],"_",orders.y[3],"_",orders.y[4],"_orders.RData",sep="") )
    val.m <- round(c(mean(sqrt(est.os2.y[,3]),na.rm=TRUE), mean(est.os2.y[,6],na.rm=TRUE), mean(sqrt(est.os2.y[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+15, 5:7 ] <- format(val.m, nsmall=4)
    val.sd <- round(c(sd(sqrt(est.os2.y[,3]),na.rm=TRUE), sd(est.os2.y[,6],na.rm=TRUE), sd(sqrt(est.os2.y[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+16, 5:7 ] <- paste( "(",format(val.sd, nsmall=4), ")",sep="")
    
  }
  
  for( l in 1:nrow(Orders2.x)){
    orders2.x <- Orders2.x[l,]
    
    load( paste("N_",m, "CentreXSymb_", ns[1], "PtsSymb_",Cov[k],"Cov_",orders2.x[1],"_",orders2.x[2],"_",orders2.x[3],"_",orders2.x[4],"_orders.RData",sep="") )
    val.m <- round(c(mean(sqrt(est.os.x[,3]),na.rm=TRUE), mean(est.os.x[,6],na.rm=TRUE), mean(sqrt(est.os.x[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+29, 1:3 ] <- format(val.m, nsmall=4)
    val.sd <- round(c(sd(sqrt(est.os.x[,3]),na.rm=TRUE), sd(est.os.x[,6],na.rm=TRUE), sd(sqrt(est.os.x[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+30, 1:3 ] <- paste( "(",format(val.sd, nsmall=4), ")",sep="")
    
    orders2.x <- orders2.x *5 
    load( paste("N_",m, "CentreXSymb_", ns[2], "PtsSymb_",Cov[k],"Cov_",orders2.x[1],"_",orders2.x[2],"_",orders2.x[3],"_",orders2.x[4],"_orders.RData",sep="") )
    val.m <- round(c(mean(sqrt(est.os.x[,3]),na.rm=TRUE), mean(est.os.x[,6],na.rm=TRUE), mean(sqrt(est.os.x[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+29, 5:7 ] <- format(val.m, nsmall=4)
    val.sd <- round(c(sd(sqrt(est.os.x[,3]),na.rm=TRUE), sd(est.os.x[,6],na.rm=TRUE), sd(sqrt(est.os.x[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+30, 5:7 ] <- paste( "(",format(val.sd, nsmall=4), ")",sep="")
    
  }  
  
  for( l in 1:nrow(Orders2.y)){
    orders2.y <- Orders2.y[l,]
    
    load( paste("N_",m, "CentreYSymb_", ns[1], "PtsSymb_",Cov[k],"Cov_",orders2.y[1],"_",orders2.y[2],"_",orders2.y[3],"_",orders2.y[4],"_orders.RData",sep="") )
    val.m <- round(c(mean(sqrt(est.os.y[,3]),na.rm=TRUE), mean(est.os.y[,6],na.rm=TRUE), mean(sqrt(est.os.y[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+43, 1:3 ] <- format(val.m, nsmall=4)
    val.sd <- round(c(sd(sqrt(est.os.y[,3]),na.rm=TRUE), sd(est.os.y[,6],na.rm=TRUE), sd(sqrt(est.os.y[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+44, 1:3 ] <- paste( "(",format(val.sd, nsmall=4), ")",sep="")
    
    orders2.y <- orders2.y *5 
    load( paste("N_",m, "CentreYSymb_", ns[2], "PtsSymb_",Cov[k],"Cov_",orders2.y[1],"_",orders2.y[2],"_",orders2.y[3],"_",orders2.y[4],"_orders.RData",sep="") )
    val.m <- round(c(mean(sqrt(est.os.y[,3]),na.rm=TRUE), mean(est.os.y[,6],na.rm=TRUE), mean(sqrt(est.os.y[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+43, 5:7 ] <- format(val.m, nsmall=4)
    val.sd <- round(c(sd(sqrt(est.os.y[,3]),na.rm=TRUE), sd(est.os.y[,6],na.rm=TRUE), sd(sqrt(est.os.y[,5]),na.rm=TRUE)),4)
    res[(l-1)*2+44, 5:7 ] <- paste( "(",format(val.sd, nsmall=4), ")",sep="")
    
  }
  
  print(xtable(res, type = "latex", digits=4))
  
}  


