###
###
### GRAPHICAL REPRESENTATIONS
###
###

### REQUIRES TO RUN LINE 1-82 OF LOG-INCOME.R

load(file="Results_LogIncome.RData")


##
## FIGURE 4
##

### FIGURE 4 (TOP LEFT)
### PLOTS THE MEAN OF T DISTRIBUTION - MODEL IS NORMAL

M.S.fDF <- matrix(tail(resS.fDF,1)[1:70], ncol=2, byrow=TRUE)
M.S.fDF.c <- matrix(tail(resS.fDF.c,1)[1:70], ncol=2, byrow=TRUE)

cbind( M.S.fDF[,1], M.S.fDF.c[,1], M.hist )

Xlim <- c(10.95, 11.35)
plot(M.S.fDF.c[,1], c(1:35), col="red", xlim=Xlim, pch=16)
points(M.S.fDF[,1], c(1:35), col="green", pch=17)
points(M.hist, c(1:35), col="blue", pch=15)

Seq <- seq(from=1, to=35, length=100)
M.c <- sapply(Seq, function(r) sum(tail(resS.fDF.c,1)[71:73] * c(r^2, r, 1))  )
M <- sapply(Seq, function(r) sum(tail(resS.fDF,1)[71:73] * c(r^2, r, 1))  )
M.BH <- sapply(Seq, function(r) sum(tail(resBH.fDF,1)[1:3] * c(r^2, r, 1))  )
points(M.c, Seq, type="l", col="red")
points(M, Seq, type="l", col="green")
points(M.BH, Seq, type="l", col="blue")


scale.S.fDF <- tail(resS.fDF,1)[74]
scale.S.fDF.c <- tail(resS.fDF.c,1)[74]
scale.BH <- tail(resBH.fDF,1)[4]
sd.tdist.S.fDF <- sqrt(scale.S.fDF * 3) # std dev = sqrt( sig^2 * df / (df-2) ), here df=3 fixed. 
sd.tdist.S.fDF.c <- sqrt(scale.S.fDF.c * 3)
sd.tdist.BH <- sqrt(scale.BH * 3)
CI.M.plus <- M + 2 * sd.tdist.S.fDF
CI.M.minus <- M - 2 * sd.tdist.S.fDF
CI.M.c.plus <- M.c + 2 * sd.tdist.S.fDF.c
CI.M.c.minus <- M.c - 2 * sd.tdist.S.fDF.c
CI.M.BH.plus <- M.BH + 2 * sd.tdist.BH
CI.M.BH.minus <- M.BH - 2 * sd.tdist.BH

points(CI.M.plus, Seq, type="l", col="green", lty=2)
points(CI.M.minus, Seq, type="l", col="green", lty=2)
points(CI.M.c.plus, Seq, type="l", col="red", lty=2)
points(CI.M.c.minus, Seq, type="l", col="red", lty=2)
points(CI.M.BH.plus, Seq, type="l", col="blue", lty=2)
points(CI.M.BH.minus, Seq, type="l", col="blue", lty=2)

### FIGURE 4 (TOP RIGHT)
### PLOTS THE MEAN OF THE INV-GAM DISTRIBUTION - MODEL IS NORMAL

sd.IGdist.S.fDF <- tail(resS.fDF,1)[76] / sqrt((tail(resS.fDF,1)[75]-1)^2 * (tail(resS.fDF,1)[75]-2)  )
sd.IGdist.S.fDF.c <- tail(resS.fDF.c,1)[76] / sqrt( (tail(resS.fDF.c,1)[75]-1)^2 * (tail(resS.fDF.c,1)[75]-2) )
sd.IGdist.BH <- tail(resBH.fDF,1)[6] / sqrt( (tail(resBH.fDF,1)[5]-1)^2 * (tail(resBH.fDF,1)[5]-2) )
CI.Sc.plus <- tail(resS.fDF,1)[76]/(tail(resS.fDF,1)[75]-1) + 2 * sd.IGdist.S.fDF
CI.Sc.minus <- tail(resS.fDF,1)[76]/(tail(resS.fDF,1)[75]-1) - 2 * sd.IGdist.S.fDF
CI.Sc.c.plus <- tail(resS.fDF.c,1)[76]/(tail(resS.fDF.c,1)[75]-1) + 2 * sd.IGdist.S.fDF.c
CI.Sc.c.minus <- tail(resS.fDF.c,1)[76]/(tail(resS.fDF.c,1)[75]-1) - 2 * sd.IGdist.S.fDF.c
CI.Sc.BH.plus <- tail(resBH.fDF,1)[6]/(tail(resBH.fDF,1)[5]-1) + 2 * sd.IGdist.BH
CI.Sc.BH.minus <- tail(resBH.fDF,1)[6]/(tail(resBH.fDF,1)[5]-1) - 2 * sd.IGdist.BH

Xlim2 <- range(M.S.fDF.c[,2], M.S.fDF[,2], S.hist, CI.Sc.c.minus, CI.Sc.minus, CI.Sc.BH.minus)
plot(M.S.fDF.c[,2], c(1:35), col="red", xlim=Xlim2, pch=16)
points(M.S.fDF[,2], c(1:35), col="green", pch=17)
points(S.hist, c(1:35), col="blue", pch=15)

abline( v=tail(resS.fDF.c,1)[76]/(tail(resS.fDF.c,1)[75]-1), col=2, lwd=2)
abline( v=tail(resS.fDF,1)[76]/(tail(resS.fDF,1)[75]-1), col=3, lwd=2)
abline( v=tail(resBH.fDF,1)[6]/(tail(resBH.fDF,1)[5]-1), col=4, lwd=2)

abline( v=CI.Sc.c.plus, col=2, lty=2, lwd=2)
abline( v=CI.Sc.c.minus, col=2, lty=2, lwd=2)
abline( v=CI.Sc.plus, col=3, lty=2, lwd=2)
abline( v=CI.Sc.minus, col=3, lty=2, lwd=2)
abline( v=CI.Sc.BH.plus, col=4, lty=2, lwd=2)
abline( v=CI.Sc.BH.minus, col=4, lty=2, lwd=2)

### FIGURE 4 (BOTTOM LEFT)
### PLOT THE MEAN OF THE T DISTRIBUTION - MODEL IS SKEW-NORMAL

M.SkSS.fDF <- matrix(tail(resSkSS.cp.fDF,1)[1:105], ncol=3, byrow=TRUE)
M.SkSS.fDF.c <- matrix(tail(resSkSS.cp.fDF.c,1)[1:105], ncol=3, byrow=TRUE)

Xlim <- c(10.95, 11.35)
plot(M.SkSS.fDF.c[,1], c(1:35), col="red", xlim=Xlim, pch=16)
points(M.SkSS.fDF[,1], c(1:35), col="green", pch=17)
points(M.hist, c(1:35), col="blue", pch=15)

Seq <- seq(from=1, to=35, length=100)
M.c <- sapply(Seq, function(r) sum(tail(resSkSS.cp.fDF.c,1)[106:108] * c(r^2, r, 1))  )
M <- sapply(Seq, function(r) sum(tail(resSkSS.cp.fDF,1)[106:108] * c(r^2, r, 1))  )
M.BH <- sapply(Seq, function(r) sum(tail(resBH.fDF,1)[1:3] * c(r^2, r, 1))  )
points(M.c, Seq, type="l", col="red")
points(M, Seq, type="l", col="green")
points(M.BH, Seq, type="l", col="blue")

scale.SkSS.fDF <- tail(resSkSS.cp.fDF,1)[109]
scale.SkSS.fDF.c <- tail(resSkSS.cp.fDF.c,1)[109]
scale.BH <- tail(resBH.fDF,1)[4]
sd.tdist.SkSS.fDF <- sqrt(scale.SkSS.fDF * 3) # std dev = sqrt( sig^2 * df / (df-2) ), here df=3 fixed. 
sd.tdist.SkSSv.fDF.c <- sqrt(scale.SkSS.fDF.c * 3)
sd.tdist.BH <- sqrt(scale.BH * 3)
CI.M.plus <- M + 2 * sd.tdist.SkSS.fDF
CI.M.minus <- M - 2 * sd.tdist.SkSS.fDF
CI.M.c.plus <- M.c + 2 * sd.tdist.SkSS.fDF.c
CI.M.c.minus <- M.c - 2 * sd.tdist.SkSS.fDF.c
CI.M.BH.plus <- M.BH + 2 * sd.tdist.BH
CI.M.BH.minus <- M.BH - 2 * sd.tdist.BH

points(CI.M.plus, Seq, type="l", col="green", lty=2)
points(CI.M.minus, Seq, type="l", col="green", lty=2)
points(CI.M.c.plus, Seq, type="l", col="red", lty=2)
points(CI.M.c.minus, Seq, type="l", col="red", lty=2)
points(CI.M.BH.plus, Seq, type="l", col="blue", lty=2)
points(CI.M.BH.minus, Seq, type="l", col="blue", lty=2)

### FIGURE 4 (BOTTOM RIGHT)
### PLOT THE MEAN OF THE T DISTRIBUTION - MODEL IS SKEW-NORMAL

sd.IGdist.SkSS.fDF <- tail(resSkSS.cp.fDF,1)[111] / sqrt((tail(resSkSS.cp.fDF,1)[110]-1)^2 * (tail(resSkSS.cp.fDF,1)[110]-2)  )
sd.IGdist.SkSS.fDF.c <- tail(resSkSS.cp.fDF.c,1)[111] / sqrt( (tail(resSkSS.cp.fDF.c,1)[110]-1)^2 * (tail(resSkSS.fDF.c,1)[110]-2) )
sd.IGdist.BH <- tail(resBH.fDF,1)[6] / sqrt( (tail(resBH.fDF,1)[5]-1)^2 * (tail(resBH.fDF,1)[5]-2) )
CI.SkSSc.plus <- tail(resSkSS.cp.fDF,1)[111]/(tail(resSkSS.cp.fDF,1)[110]-1) + 2 * sd.IGdist.SkSS.fDF
CI.SkSSc.minus <- tail(resSkSS.cp.fDF,1)[111]/(tail(resSkSS.cp.fDF,1)[110]-1) - 2 * sd.IGdist.SkSS.fDF
CI.SkSSc.c.plus <- tail(resSkSS.cp.fDF.c,1)[111]/(tail(resSkSS.cp.fDF.c,1)[110]-1) + 2 * sd.IGdist.SkSS.fDF.c
CI.SkSSc.c.minus <- tail(resSkSS.cp.fDF.c,1)[111]/(tail(resSkSS.cp.fDF.c,1)[110]-1) - 2 * sd.IGdist.SkSS.fDF.c
CI.SkSSc.BH.plus <- tail(resBH.fDF,1)[6]/(tail(resBH.fDF,1)[5]-1) + 2 * sd.IGdist.BH
CI.SkSSc.BH.minus <- tail(resBH.fDF,1)[6]/(tail(resBH.fDF,1)[5]-1) - 2 * sd.IGdist.BH

Xlim2 <- range(M.SkSS.fDF.c[,2], M.SkSS.fDF[,2], S.hist, CI.SkSSc.c.minus, CI.SkSSc.minus, CI.SkSSc.BH.minus)
plot(M.SkSS.fDF.c[,2], c(1:35), col="red", xlim=Xlim2, pch=16)
points(M.SkSS.fDF[,2], c(1:35), col="green", pch=17)
points(S.hist, c(1:35), col="blue", pch=15)

abline( v=tail(resSkSS.cp.fDF.c,1)[111]/(tail(resSkSS.cp.fDF.c,1)[110]-1), col=2, lwd=2)
abline( v=tail(resSkSS.fDF,1)[111]/(tail(resSkSS.fDF,1)[110]-1), col=3, lwd=2)
abline( v=tail(resBH.fDF,1)[6]/(tail(resBH.fDF,1)[5]-1), col=4, lwd=2)

abline( v=CI.SkSSc.c.plus, col=2, lty=2, lwd=2)
abline( v=CI.SkSSc.c.minus, col=2, lty=2, lwd=2)
abline( v=CI.SkSSc.plus, col=3, lty=2, lwd=2)
abline( v=CI.SkSSc.minus, col=3, lty=2, lwd=2)
abline( v=CI.SkSSc.BH.plus, col=4, lty=2, lwd=2)
abline( v=CI.SkSSc.BH.minus, col=4, lty=2, lwd=2)



##
## FIGURE 5
##


## Select a risk group
r <- which(risks == "C3")
n.r <- Ns[r]
par.s <- resSkSS.cp.fDF[which.max(resSkSS.cp.fDF[,114]),106:113]
par.LRB <- resBH.fDF[which.max(resBH.fDF[,7]),1:6]
  
# Bin location of Group histogram
dat <- loanDF1[which(loanDF1$sub_grade==risks[r]) , ]$annual_inc_ln 
bin.loc <- seq(from=min(dat)-1e-10, to=max(dat)+1e-10,  length=6 )
bin.loc.down <- head(bin.loc,-1)
bin.loc.up <- tail(bin.loc,-1)


# Compute the predictive distributions
repeats <- 10000
set.seed(14342)
MeanVar <- MeanVarSymb <- MeanVarLRB <- MeanVarHist <- matrix(ncol=2, nrow=repeats)

pb <-  txtProgressBar(min = 0, max = repeats, initial = 0, style=3) #creates a prgress bar
for(i in 1:repeats){

  setTxtProgressBar(pb, i)
  
  mean.par <- rt(1, df=3) * sqrt(par.s[4]/3) + par.s[1]*r^2 + par.s[2]*r + par.s[3]
  sig.par <- rinvgamma(1, shape=par.s[5], scale=par.s[6])
  skew.par <- rnorm(1, mean=par.s[7], sd=sqrt(par.s[8]))
  if( abs(skew.par) >= (4-pi)/2 * (2 / (pi-2))^(3/2) ){skew.par <- rnorm(1, mean=par.s[7], sd=sqrt(par.s[8]))}
  par.symb <- cp2dp( c(mean.par, sqrt(sig.par), skew.par), "SN")
  
  tmp <- rsn(n.r, dp=par.symb)
  
  # Prediction at data level
  MeanVar[i,] <- c(mean(tmp), var(tmp))
  tmp.hist <- hist(tmp, breaks=seq(from=min(tmp)-1e-10, to=max(tmp)+1e-10,  length=6 ), plot=FALSE)
  
  # Prediciton LRB
  A <- head(tmp.hist$breaks,-1)
  B <- tail(tmp.hist$breaks,-1)
  MeanVarHist[i,1] <- sum((A+B) * tmp.hist$counts)  /(2*n.r)
  MeanVarHist[i,2] <- sum(tmp.hist$counts * (A^2 + A*B + B^2) )/(3*n.r) - (MeanVarHist[i,1])^2
  
  MeanVarLRB[i,1] <- rt(1, df=3) * sqrt(par.LRB[4]/3) + par.LRB[1]*r^2 + par.LRB[2]*r + par.LRB[3]  
  MeanVarLRB[i,2] <- rinvgamma(1, shape=par.LRB[5], scale=par.LRB[6])   
  
  # Prediction symbol level
  # Calculate Probabilities to fall in bins
  bin.prob <- c(0,psn(bin.loc, dp=par.symb))
  bin.proba <- bin.prob[-1] - head(bin.prob,-1)
  if( any(bin.proba<0) ){ bin.proba[which(bin.proba<0)] <- 0}
  # Generate counts of histogram
  Counts <- rmultinom(1, size=n.r, prob = bin.proba[-1])
  # Compute mean and variance of histogram
  MeanVarSymb[i,1] <- sum((bin.loc.down + bin.loc.up) * Counts)  /(2*n.r)
  MeanVarSymb[i,2] <- sum(Counts * (bin.loc.down^2 + bin.loc.down*bin.loc.up + bin.loc.up^2) )/(3*n.r) - (MeanVarSymb[i,1])^2
  
}


XL= range(MeanVar[,1], MeanVarLRB[,1], MeanVarHist[,1])
YL= range(MeanVar[,2], MeanVarLRB[,2], MeanVarHist[,2])

XL <- c(10.95,11.1)
YL <- c(0.2,0.85)

# 1) Predictive distribution data level (Fig 5 - Middle panel)

par(mar=c(3.5,4.2,1.1,0.8))
contour(kde2d(MeanVar[,1], MeanVar[,2], n=100, lims=c(XL,YL)),
        xlim=XL, ylim=YL, nlevels = 8, xlab="", ylab="",
        main="Loan grade C3", drawlabels=FALSE, lty=1, lwd=2, cex.axis=1.4)
title(ylab=expression(sigma^2), line=2.5, cex.lab=1.7)
title(xlab=expression(mu), line=2.5, cex.lab=1.7)
points(class.data[[r]]$data[1], class.data[[r]]$data[2]^2, pch=16, cex=1.5 )
contour(kde2d(MeanVarLRB[,1], MeanVarLRB[,2], n=100, lims=c(XL,YL)),
        nlevels = 8, add=TRUE, drawlabels=FALSE, lty=2, lwd=2)
dev.copy2pdf(file="GradeC3_pred_data.pdf")

# 2) Predictive distirbution symbol level (Fig 5 - Right panel)

par(mar=c(3.5,4.2,1.1,0.8))
contour(kde2d(MeanVarLRB[,1], MeanVarLRB[,2], n=100, lims=c(XL,YL)), xlim=XL, ylim=YL, 
        main="Loan grade C3", xlab="", ylab="", nlevels = 8, drawlabels=FALSE, lty=2, lwd=2, cex.axis=1.4)
title(ylab=expression(sigma^2), line=2.5, cex.lab=1.7)
title(xlab=expression(mu), line=2.5, cex.lab=1.7)
points(M.hist[r], S.hist[r], pch=15, col="blue", cex=1.5)
contour(kde2d(MeanVarSymb[,1], MeanVarSymb[,2], n=100, lims=c(XL,YL)),
        xlim=c(10.5,11.5), ylim=c(0.2,1), nlevels = 8, add=TRUE, drawlabels=FALSE, lty=1, lwd=2)
dev.copy2pdf(file="GradeC3_pred_symb.pdf")


# 3) QQ-plot (Fig 5 - Left panel)

## Select a risk group
r <- which(risks == "C3")
n.r <- Ns[r]
par.n <- resS.fDF[which.max(resS.fDF[,77]),((2*r-1):(2*r))]
par.sn <- resSkSS.cp.fDF[which.max(resSkSS.cp.fDF[,114]),((3*r-2):(3*r))]

emp.quant <- sort(class.data.sk[[r]]$data)
probs <- (1:n.r)/n.r
norm.quant <- qnorm(probs, mean=par.n[1], sd=sqrt(par.n[2]))
snorm.quant <- qsn(probs, dp=cp2dp(c(par.sn[1], sqrt(par.sn[2]), par.sn[3]),"SN"))

index <- c(1:500, seq(from=1, to=n.r, by=120),(n.r-500):n.r) # Don't want to plot over 50,000 points!!!

par(mar=c(3.5,4.2,1.1,0.8))
plot(norm.quant[index], emp.quant[index], col="red", pch=16, cex.axis=1.4, lwd=2,
     main="Loan grade C3", xlab="", ylab="")
title(ylab="Sample Quantiles of ln-income", line=2.5, cex.lab=1.5)
title(xlab="Fitted Quantiles of ln-income", line=2.5, cex.lab=1.5)
abline(a=0, b=1, lwd=2)
points(snorm.quant[index], emp.quant[index], col="green", pch=16, lwd=2)

dev.copy2pdf(file="GradeC3_QQplot.pdf")
